#pragma once

#include "Areas.h"

#include <MiniSAX.h>

using	miniSAX::CMiniSAXException;
using	miniSAX::CContentHandler;
using	miniSAX::CAttribute;
using	miniSAX::CAttributeList;
using	miniSAX::CMiniSAXParser;

/*******************************************
  Classes to parse areas configuration data
 *******************************************/

class CAreasContentHandler : public CContentHandler {
public:
    CAreasContentHandler(CMiniSAXParser* aParser);
    virtual ~CAreasContentHandler();

    virtual void startElement(const char* name, CAttributeList& attributes)
        throw (CMiniSAXException);
    virtual void endElement(const char* name)
        throw (CMiniSAXException);

    virtual void handleCharacters(const char* buffer, size_t len)
        throw (CMiniSAXException);

protected:
	enum State {
		ROOT_STATE,
		AREAS_STATE,
		GROUP_STATE,
		AREA_STATE,
		PASSTHROUGH_STATE,
		VETO_MANUAL_PURGE_STATE,
		OPEN_FOR_RESEND_STATE,
		OUTBOUND_STATE,
		FILEFLAG_STATE,
		AREA_RENAMEFILEPLAN_STATE,
		LINKED_STATE
	};
	State	state;

	CMiniSAXParser*	parser;
	PAreaGroup		group;
	PArea			area;
	int				linkRouting;
	tstring			fileFlagMask;
};
