#pragma once

#include <MiniSAX.h>

using miniSAX::CCharSetConvertor;

class CConfigWriter  
{
public:
	CConfigWriter(const tstring& aFileName, LPCTSTR sourceEncoding = NULL, LPCTSTR destEncoding = NULL);
	virtual ~CConfigWriter();

	void close();
	/**
	 * We can cancel file creation when we don't close it yet.
	 * Temporary file will be removed.
	 * If file was already created (closed) this method does nothing.
	 */
	void cancel();

	class CEntityResolver {
	public:
		CEntityResolver() {}
	};

	CConfigWriter& operator <<(const tstring& data);
	CConfigWriter& operator <<(LPCTSTR data);
	CConfigWriter& operator <<(const int data);
	CConfigWriter& operator <<(const CEntityResolver& resolver);

protected:
	tstring		fileName;
	tstring		tempFileName;
	ofstream	out;
	bool		closed;
	bool		resolveEntities;
	tstring		resolvedData;
	bool		oemData;

	CCharSetConvertor	charSetConvertor;
	bool				needConvertion;
	char*				convertBuffer;
	int					bufferLen;

	char* encode(LPCTSTR data);

	void print(LPCTSTR data);
	void resolve(LPCTSTR data);
};
