#pragma once

#include "Address.h"

class CMessage
{
public:
	CMessage(void);
	virtual ~CMessage(void);

	// sender

	const tstring&	getSenderName() const				{ return m_senderName; }
	tstring&		getSenderName()						{ return m_senderName; }
	void			setSenderName(const tstring& name)	{ m_senderName = name; }

	const CAddress& getSenderAddress() const					{ return m_senderAddress;    }
	CAddress&		getSenderAddress()							{ return m_senderAddress;    }
	void			setSenderAddress(const CAddress& address)	{ m_senderAddress = address; }

	// receiver

	const tstring&	getReceiverName() const					{ return m_receiverName; }
	tstring&		getReceiverName()						{ return m_receiverName; }
	void			setReceiverName(const tstring& name)	{ m_receiverName = name; }

	const CAddress& getReceiverAddress() const					{ return m_receiverAddress;    }
	CAddress&		getReceiverAddress()						{ return m_receiverAddress;    }
	void			setReceiverAddress(const CAddress& address)	{ m_receiverAddress = address; }

protected:
	tstring		m_senderName;
	CAddress	m_senderAddress;
	tstring		m_receiverName;
	CAddress	m_receiverAddress;
};

typedef CMessage*		MessagePtr;
typedef const CMessage*	ConstMessagePtr;
