#include "stdafx.h"
#include "attributelistimpl.h"

CAttributeListImpl::CAttributeListImpl(void)
{
}

CAttributeListImpl::~CAttributeListImpl(void)
{
}

const CAttribute* CAttributeListImpl::getAttribute(const char* name) {
	return getAttribute( name, 1 );
}


const CAttribute* CAttributeListImpl::getAttribute(const char* name, size_t n) {
	size_t	count = m_attributes.size();
	for (size_t i = 0; i < count; i++) {
		if (strcmp( m_attributes[i].getName(), name ) == 0) {
			--n;
			if (n == 0) {
				// remember name
				m_requestedNames.push_back( name );
				return &(m_attributes[i]);
			}
		}
	}

	return NULL;
}


void CAttributeListImpl::checkUnexpected() throw(CMiniSAXException) {
	size_t	attrCount = m_attributes.size();
	for (size_t	i = 0; i < attrCount; i++) {
		size_t	nameCount = m_requestedNames.size();
		size_t	j         = 0;
		while (j < nameCount) {
			if (strcmp( m_requestedNames[j].c_str(), m_attributes[i].getName()) == 0) {
				// remove name to avoid further processing
				m_requestedNames.erase( m_requestedNames.begin() + j );
				break;
			}
			++j;
		}
		if (j >= nameCount) {
			// name not found => attribute wasn't requested
			throw CMiniSAXException( (std::string("Unexpected attribute '") + m_attributes[i].getName() + "'").c_str() );
		}
	}
}
